/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.mangue.client.select;

import java.awt.BorderLayout;
import java.awt.Color;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.application.client.swing.ZEOTableModelColumnWithProvider;
import org.cocktail.application.client.swing.ZEOTableModelColumnWithProvider.ZEOTableModelColumnProvider;
import org.cocktail.mangue.common.modele.gpeec.EOEmploi;
import org.cocktail.mangue.common.modele.interfaces.INomenclature;
import org.cocktail.application.common.utilities.CocktailFormats;
import org.cocktail.mangue.common.utilities.CocktailIcones;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class EmploiSelectView extends javax.swing.JDialog {

	private static final long serialVersionUID = -978106758741617493L;
	protected EODisplayGroup eod;
	protected ZEOTable myEOTable;
	protected ZEOTableModel myTableModel;
	protected TableSorter myTableSorter;
	protected ZEOTableModelColumnProvider provider;
    
    /** Creates new form TemplateJDialog */
    public EmploiSelectView(java.awt.Frame parent, boolean modal, EODisplayGroup displayGroup, ZEOTableModelColumnProvider provider) {
        super(parent, modal);

        eod = displayGroup;
        this.provider = provider;
        
        initComponents();
        initGui();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTable = new javax.swing.JPanel();
        buttonSelectionner = new javax.swing.JButton();
        buttonAnnuler = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        tfFiltreNumero = new javax.swing.JTextField();
        lblNbEmplois = new javax.swing.JLabel();
        panelTypeEmploi = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        popupType = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Sélection RNE");

        viewTable.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewTable.setLayout(new java.awt.BorderLayout());

        buttonSelectionner.setText("Sélectionner");
        buttonSelectionner.setIconTextGap(2);
        buttonSelectionner.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonSelectionnerActionPerformed(evt);
            }
        });

        buttonAnnuler.setText("Annuler");
        buttonAnnuler.setIconTextGap(2);

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel4.setText("Numéro ?");

        lblNbEmplois.setFont(new java.awt.Font("Tahoma", 0, 12));
        lblNbEmplois.setForeground(new java.awt.Color(0, 0, 255));
        lblNbEmplois.setText("jLabel2");

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText("Type");

        popupType.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        org.jdesktop.layout.GroupLayout panelTypeEmploiLayout = new org.jdesktop.layout.GroupLayout(panelTypeEmploi);
        panelTypeEmploi.setLayout(panelTypeEmploiLayout);
        panelTypeEmploiLayout.setHorizontalGroup(
            panelTypeEmploiLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelTypeEmploiLayout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 46, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(popupType, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 245, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );
        panelTypeEmploiLayout.setVerticalGroup(
            panelTypeEmploiLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelTypeEmploiLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelTypeEmploiLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(popupType, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 570, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(panelTypeEmploi, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(35, 35, 35)
                        .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(18, 18, 18)
                        .add(tfFiltreNumero, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 104, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(lblNbEmplois, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 154, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 200, Short.MAX_VALUE)
                        .add(buttonAnnuler, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonSelectionner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel4)
                            .add(tfFiltreNumero, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(panelTypeEmploi, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 41, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(8, 8, 8)
                .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 563, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(buttonAnnuler, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(buttonSelectionner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(lblNbEmplois))
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-596)/2, (screenSize.height-683)/2, 596, 683);
    }// </editor-fold>//GEN-END:initComponents

private void buttonSelectionnerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonSelectionnerActionPerformed

    dispose();

}//GEN-LAST:event_buttonSelectionnerActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
            	BanqueSelectView dialog = new BanqueSelectView(new javax.swing.JFrame(), true, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonAnnuler;
    private javax.swing.JButton buttonSelectionner;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel lblNbEmplois;
    private javax.swing.JPanel panelTypeEmploi;
    private javax.swing.JComboBox popupType;
    private javax.swing.JTextField tfFiltreNumero;
    private javax.swing.JPanel viewTable;
    // End of variables declaration//GEN-END:variables

	private void initGui() {
        
		setTitle("Sélection d'un EMPLOI");
		
    	buttonSelectionner.setIcon(CocktailIcones.ICON_COCHE);
        buttonAnnuler.setIcon(CocktailIcones.ICON_CANCEL);
        
        popupType.removeAllItems();
        popupType.addItem("Emplois vacants");
        popupType.addItem("Rompus de temps partiel");
        
        Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

    	ZEOTableModelColumn	col = new ZEOTableModelColumn(eod, EOEmploi.NO_EMPLOI_AFFICHAGE_KEY, "Emploi", 75);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, EOEmploi.DATE_EFFET_EMPLOI_KEY, "Effet", 80);
    	col.setAlignment(SwingConstants.CENTER);
		col.setColumnClass(java.util.Date.class);
		col.setFormatDisplay(CocktailFormats.FORMAT_DATE_DDMMYYYY);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, EOEmploi.TO_RNE_KEY + "." + INomenclature.CODE_KEY, "UAI", 75);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);/*
    	//FIXME : Trouver d'où vient pb de lenteur avant de remettre
    	col = new ZEOTableModelColumn(eod, EOEmploi.CATEGORIE_EMPLOI_COURANTE, "Catégorie Emploi", 75);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);*/
    	col = new ZEOTableModelColumnWithProvider("Quotité à occuper", provider, 50); 
		col.setColumnClass(java.math.BigDecimal.class);
		col.setFormatDisplay(CocktailFormats.FORMAT_DECIMAL);
    	col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);

		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		

		myEOTable.setBackground(new Color(230, 230, 230));
		myEOTable.setSelectionBackground(new Color(127,155,165));
		myEOTable.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		
		viewTable.setLayout(new BorderLayout());
		viewTable.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTable.removeAll();
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);
		
    }

	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}

	public javax.swing.JButton getButtonAnnuler() {
		return buttonAnnuler;
	}

	public void setButtonAnnuler(javax.swing.JButton buttonAnnuler) {
		this.buttonAnnuler = buttonAnnuler;
	}

	public javax.swing.JButton getButtonSelectionner() {
		return buttonSelectionner;
	}

	public void setButtonSelectionner(javax.swing.JButton buttonSelectionner) {
		this.buttonSelectionner = buttonSelectionner;
	}

	public javax.swing.JTextField getTfFiltreNumero() {
		return tfFiltreNumero;
	}

	public void setTfFiltreNumero(javax.swing.JTextField tfFiltreNumero) {
		this.tfFiltreNumero = tfFiltreNumero;
	}

	public javax.swing.JComboBox getPopupType() {
		return popupType;
	}

	public void setPopupType(javax.swing.JComboBox popupType) {
		this.popupType = popupType;
	}

	public javax.swing.JLabel getLblNbEmplois() {
		return lblNbEmplois;
	}

	public void setLblNbEmplois(javax.swing.JLabel lblNbEmplois) {
		this.lblNbEmplois = lblNbEmplois;
	}

	public javax.swing.JPanel getPanelTypeEmploi() {
		return panelTypeEmploi;
	}

	public void setPanelTypeEmploi(javax.swing.JPanel panelTypeEmploi) {
		this.panelTypeEmploi = panelTypeEmploi;
	}


}
